import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import cx from 'classnames';
import SUILoader from './SUILoader';
var TYPES = {
  FULL: 'full',
  SECTION: 'section'
};
var DELAY = 500; // ms

var BASE_CLASS = 'sui-AtomSpinner';
var CLASS_FULL = BASE_CLASS + "--fullPage";
var CLASS_NO_BACKGROUND = BASE_CLASS + "--noBackground";

var AtomSpinner =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(AtomSpinner, _Component);

  function AtomSpinner() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.state = {
      delayed: _this.props.delayed
    };
    return _this;
  }

  var _proto = AtomSpinner.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    if (!this.state.delayed) {
      this._addParentClass();

      return;
    }

    this.timer = setTimeout(function () {
      _this2.setState({
        delayed: false
      }, _this2._addParentClass);
    }, DELAY);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    clearTimeout(this.timer);

    this._removeParentClass();
  };

  _proto._removeParentClass = function _removeParentClass() {
    var _this$_parentNodeClas;

    (_this$_parentNodeClas = this._parentNodeClassList).remove.apply(_this$_parentNodeClas, this._parentClassName.split(' '));
  };

  _proto._addParentClass = function _addParentClass() {
    var _this$_parentNodeClas2;

    (_this$_parentNodeClas2 = this._parentNodeClassList).add.apply(_this$_parentNodeClas2, this._parentClassName.split(' '));
  };

  _proto.render = function render() {
    var loader = this.props.loader;
    var delayed = this.state.delayed;
    return !delayed ? loader : React.createElement("noscript", null);
  };

  _createClass(AtomSpinner, [{
    key: "_parentNodeClassList",
    get: function get() {
      if (this._parentNodeClassListCache) return this._parentNodeClassListCache;
      this._parentNodeClassListCache = ReactDOM.findDOMNode(this).parentNode.classList;
      return this._parentNodeClassListCache;
    }
  }, {
    key: "_parentClassName",
    get: function get() {
      var _cx;

      var _this$props = this.props,
          type = _this$props.type,
          noBackground = _this$props.noBackground;
      return cx((_cx = {}, _cx[BASE_CLASS] = type === TYPES.SECTION, _cx[CLASS_FULL] = type === TYPES.FULL, _cx[CLASS_NO_BACKGROUND] = noBackground, _cx));
    }
  }]);

  return AtomSpinner;
}(Component);

AtomSpinner.displayName = 'AtomSpinner';
AtomSpinner.defaultProps = {
  delayed: false,
  type: TYPES.SECTION,
  loader: React.createElement(SUILoader, null)
};
export default AtomSpinner;
export { TYPES as AtomSpinnerTypes };